<script setup>
import { ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import api from "../../api";
import axios from "axios";

// Get route information
const route = useRoute();
const buku = ref(null);
const genre = ref(null);
const quantity = ref(1);
const user_id = ref(1);
const router = useRouter();

// Fetch book details based on the id parameter
const fetchBookDetails = async () => {
  try {
    const response = await api.get(`/buku/${route.params.id}`);
    buku.value = response.data.bukus;
    genre.value = response.data.genre;
  } catch (error) {
    console.error("Error fetching book details:", error);
  }
};

// Method to handle form submission
const addToCart = () => {
  const data = {
    qty: quantity.value,
    buku_id: route.params.id,
    user_id: 1,
  };

  axios
    .post("http://localhost:8000/api/keranjang", data)
    .then((response) => {
      console.log("Cart submitted successfully:", response.data);
      // Handle successful submission (e.g., show a success message)

      // Redirect to Cart page
      router.push({ name: "pages.Cart" });
    })
    .catch((error) => {
      console.error("Error submitting cart:", error.response.data);
      // Handle error (e.g., show an error message)
    });
};

const directPurchase = () => {
  const data = {
    qty: quantity.value,
    buku_id: route.params.id
  };
  router.push({ name: "pages.Order", params: { source: 'katalog', ...data } });
};

// Fetch the book details when the component is mounted
onMounted(() => {
  fetchBookDetails();
});
</script>

<template>
  <section class="pt-5" v-if="buku">
    <div class="container-fluid pt-5">
      <div class="row m-4">
        <div class="col-sm-1"></div>
        <div class="col-sm-3 text-center">
          <img :src="buku.cover" width="200" height="300" />
        </div>
        <div class="col-sm-7">
          <div class="row">
            <div class="col-8 col-sm-7">
              <p>
                <span class="fs-6" style="color: grey">{{ buku.author }}</span>
                <br />
                <span class="fs-3" style="font-weight: 500">{{
                  buku.title
                }}</span>
                <br />
                <span class="fs-5">{{ genre }}</span>
              </p>
              <span class="fs-3" style="color: darkcyan">Rp{{
                buku.price.toLocaleString("id-ID", {
                  minimumFractionDigits: 2,
                })
              }}</span>
              <hr width="100%" />
              <b style="font-size: large">Sinopsis Buku</b>
              <p style="
                  font-family: 'Times New Roman';
                  font-size: 17px;
                  text-align: justify;
                ">
                {{ buku.synopsis }}
              </p>
            </div>
            <div class="col-4 col-sm-5">
              <h2>Ingin beli berapa?</h2>
              <form @submit.prevent="addToCart">
                <div class="input-container">
                  <input type="hidden" name="pmentdate" :value="new Date().toISOString().slice(0, 10)" />
                </div>
                <label for="qty" class="form-label" style="font-size: 19px; font-style: Segoe ui">
                  Jumlah Buku
                </label>
                <input type="number" id="qty" class="form-control mb-3" style="width: 370px" v-model="quantity"
                  min="1" />
                <button type="submit" class="btn me-2" style="
                    text-align: center;
                    border-color: #0d6efd;
                    color: #0d6efd;
                  ">
                  + Keranjang
                </button>
                <button type="button" class="btn btn-primary" @click="directPurchase">Beli Sekarang</button>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<style>
.overlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5);
  display: none;
}

.alert {
  position: fixed;
  z-index: 1000;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background-color: #d4edda;
  border-color: #d4edda;
  color: black;
  padding: 15px;
  border-radius: 5px;
  max-width: 300px;
  text-align: center;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

.alert-success {
  background-color: #d4edda;
  border-color: #c3e6cb;
  color: #155724;
}

.alert-danger {
  background-color: #f8d7da;
  border-color: #f5c6cb;
  color: #721c24;
}

.alert p {
  margin: 0;
}

.alert button {
  margin-top: 10px;
  padding: 5px 15px;
  background-color: #0d6efd;
  color: #fff;
  border: none;
  border-radius: 3px;
  cursor: pointer;
}

.alert button:hover {
  background-color: #0056b3;
}
</style>
